/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.unisef.tasks.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.GroupedModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Task service. Represents a row in the &quot;TK_Task&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link it.unisef.tasks.model.impl.TaskModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link it.unisef.tasks.model.impl.TaskImpl}.
 * </p>
 *
 * @author Giulio Piemontese
 * @see Task
 * @see it.unisef.tasks.model.impl.TaskImpl
 * @see it.unisef.tasks.model.impl.TaskModelImpl
 * @generated
 */
public interface TaskModel extends BaseModel<Task>, GroupedModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a task model instance should use the {@link Task} interface instead.
	 */

	/**
	 * Returns the primary key of this task.
	 *
	 * @return the primary key of this task
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this task.
	 *
	 * @param primaryKey the primary key of this task
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the task ID of this task.
	 *
	 * @return the task ID of this task
	 */
	public long getTaskId();

	/**
	 * Sets the task ID of this task.
	 *
	 * @param taskId the task ID of this task
	 */
	public void setTaskId(long taskId);

	/**
	 * Returns the group ID of this task.
	 *
	 * @return the group ID of this task
	 */
	public long getGroupId();

	/**
	 * Sets the group ID of this task.
	 *
	 * @param groupId the group ID of this task
	 */
	public void setGroupId(long groupId);

	/**
	 * Returns the company ID of this task.
	 *
	 * @return the company ID of this task
	 */
	public long getCompanyId();

	/**
	 * Sets the company ID of this task.
	 *
	 * @param companyId the company ID of this task
	 */
	public void setCompanyId(long companyId);

	/**
	 * Returns the user ID of this task.
	 *
	 * @return the user ID of this task
	 */
	public long getUserId();

	/**
	 * Sets the user ID of this task.
	 *
	 * @param userId the user ID of this task
	 */
	public void setUserId(long userId);

	/**
	 * Returns the user uuid of this task.
	 *
	 * @return the user uuid of this task
	 * @throws SystemException if a system exception occurred
	 */
	public String getUserUuid() throws SystemException;

	/**
	 * Sets the user uuid of this task.
	 *
	 * @param userUuid the user uuid of this task
	 */
	public void setUserUuid(String userUuid);

	/**
	 * Returns the user name of this task.
	 *
	 * @return the user name of this task
	 */
	@AutoEscape
	public String getUserName();

	/**
	 * Sets the user name of this task.
	 *
	 * @param userName the user name of this task
	 */
	public void setUserName(String userName);

	/**
	 * Returns the create date of this task.
	 *
	 * @return the create date of this task
	 */
	public Date getCreateDate();

	/**
	 * Sets the create date of this task.
	 *
	 * @param createDate the create date of this task
	 */
	public void setCreateDate(Date createDate);

	/**
	 * Returns the modified date of this task.
	 *
	 * @return the modified date of this task
	 */
	public Date getModifiedDate();

	/**
	 * Sets the modified date of this task.
	 *
	 * @param modifiedDate the modified date of this task
	 */
	public void setModifiedDate(Date modifiedDate);

	/**
	 * Returns the title of this task.
	 *
	 * @return the title of this task
	 */
	@AutoEscape
	public String getTitle();

	/**
	 * Sets the title of this task.
	 *
	 * @param title the title of this task
	 */
	public void setTitle(String title);

	/**
	 * Returns the description of this task.
	 *
	 * @return the description of this task
	 */
	@AutoEscape
	public String getDescription();

	/**
	 * Sets the description of this task.
	 *
	 * @param description the description of this task
	 */
	public void setDescription(String description);

	/**
	 * Returns the expiration date of this task.
	 *
	 * @return the expiration date of this task
	 */
	public Date getExpirationDate();

	/**
	 * Sets the expiration date of this task.
	 *
	 * @param expirationDate the expiration date of this task
	 */
	public void setExpirationDate(Date expirationDate);

	/**
	 * Returns the completed of this task.
	 *
	 * @return the completed of this task
	 */
	public boolean getCompleted();

	/**
	 * Returns <code>true</code> if this task is completed.
	 *
	 * @return <code>true</code> if this task is completed; <code>false</code> otherwise
	 */
	public boolean isCompleted();

	/**
	 * Sets whether this task is completed.
	 *
	 * @param completed the completed of this task
	 */
	public void setCompleted(boolean completed);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(Task task);

	public int hashCode();

	public CacheModel<Task> toCacheModel();

	public Task toEscapedModel();

	public String toString();

	public String toXmlString();
}